#include<bits/stdc++.h>
using namespace std;
const int N=5e5+5;
int n,m,ans;
vector<int> e[N];
bool vis[N];
int dep[N],fa[N];
void dfs(int u,int faa){
	dep[u]=dep[faa]+1;
	fa[u]=faa;
	for(auto j:e[u]){
		if(j==faa) continue;
		dfs(j,u);
	}
	return;
}
int LCA(int x,int y){
	if(dep[x]<dep[y]) swap(x,y);
	while(dep[x]!=dep[y])
		x=fa[x];
	while(x!=y){
		x=fa[x];y=fa[y];
	}
	return x;
}
int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	ios::sync_with_stdio(0);
	cin.tie(0);
	bool flag=1;
	cin>>n;
	for(int i=1;i<n;i++){
		int u,v;
		cin>>u>>v;
		e[u].push_back(v);
		e[v].push_back(u);
	}
	if(e[1].size()>1) flag=0;
	else{
		for(int i=2;i<=n;i++){
			if(e[i].size()>2){
				flag=0;
				break;
			}
		}
	}
	dfs(1,0);
	fa[1]=1;
	//for(int i=1;i<=n;i++)	cerr<<dep[i]<<" ";
	cin>>m;
	//cerr<<flag<<"\n";
	if(flag){
		for(int i=1;i<=m;i++){
			int l,r,k;
			cin>>l>>r>>k;
			k--;
			ans=0;
			for(int i=l;i<=r-k;++i){
				int tmp=min(dep[i],dep[i+k]);
				//cerr<<tmp<<" ";
				ans=max(ans,tmp);
			}
			cout<<ans<<"\n";
		}
	}
	else{
		for(int i=1;i<=m;i++){
			int l,r,k;
			cin>>l>>r>>k;
			k--;
			ans=0;
			for(int i=l;i<=r-k;++i){
				int tmp=dep[LCA(i,i+k)];
				ans=max(ans,tmp);
			}
			cout<<ans<<"\n";
		}
	}
	return 0;
}

